@echo off

rem Extract contents from a PAR pp packed ExifTool executable
rem and combine it with the "Portable PerlLauncher" .exe

setlocal EnableDelayedExpansion

if not exist %1 (
  echo %1 does not esist
  goto end
)

if not exist %~dp0\pplx.exe (
  echo you need to have pplx.exe in the same directory as %~dp0
  goto end
)

rem %CD% is the directory of the source file when we are called by drag/drop
set unpar_out=%CD%\%~n1-unpar

echo unpar %1 to directory %unpar_out%

rem make a random temp directory to extract the PAR self extracting archive
set PAR_GLOBAL_TEMP=%CD%\parextract_%random%

if exist %PAR_GLOBAL_TEMP% (
  echo Temp directory %PAR_GLOBAL_TEMP% already exists - run again to use a different directory
  goto end
)

if exist %unpar_out% (
  echo Target directory %unpar_out% already exists - please rename or delete it and run again
  goto end
)
mkdir %unpar_out%
mkdir %unpar_out%\exiftool_files

echo Now we unpack the PAR archive to %PAR_GLOBAL_TEMP%
echo This will run the application once, quit it to proceed!
echo exiftool -ver avoids the long help output
%1 -ver

move %PAR_GLOBAL_TEMP%\inc\lib %unpar_out%\exiftool_files\lib
del  %PAR_GLOBAL_TEMP%\inc\script\main.pl
ren %PAR_GLOBAL_TEMP%\inc\script\*. *.pl
move %PAR_GLOBAL_TEMP%\inc\script\* %unpar_out%\exiftool_files
move %PAR_GLOBAL_TEMP%\perl5*.dll %unpar_out%\exiftool_files

rem the following libs are needed by Strawberry Perl:
if exist %PAR_GLOBAL_TEMP%\libgcc*.dll        move %PAR_GLOBAL_TEMP%\libgcc*.dll %unpar_out%\exiftool_files
if exist %PAR_GLOBAL_TEMP%\libstdc*.dll       move %PAR_GLOBAL_TEMP%\libstdc*.dll %unpar_out%\exiftool_files
if exist %PAR_GLOBAL_TEMP%\libwinpthread*.dll move %PAR_GLOBAL_TEMP%\libwinpthread*.dll %unpar_out%\exiftool_files

copy %~dp0\pplx.exe %unpar_out%

ren %unpar_out%\pplx.exe exiftool.exe

echo You should now delete the temporary directory:
rmdir /S %PAR_GLOBAL_TEMP%
goto endnopause

:end
pause

:endnopause
endlocal

